document.addEventListener("deviceready",
	function(){
		startTJ();

		window.AppodealAdAvailable = false;

		Appodeal.enableRewardedVideoCallbacks(true);

		document.addEventListener('onRewardedVideoShown', function(){cr_setSuspended(true);});
		document.addEventListener('onRewardedVideoFailedToLoad', function(){cr_setSuspended(false);});
		//document.addEventListener('onRewardedVideoFinished', function(){cr_setSuspended(false);});
		document.addEventListener('onRewardedVideoClosed', function(){cr_setSuspended(false);});

		window.AppodealCheck = setInterval(function(){
			if(AppodealAdAvailable) return;
			Appodeal.isLoaded(Appodeal.REWARDED_VIDEO, function(result){
				AppodealAdAvailable = result;
			});
		},3000);
	}, false
);

/*
function getCookie(cname, defaultVal) {
	defaultVal = defaultVal || "";
	var ret = window.localStorage.getItem(cname);
	if(ret == null) return defaultVal
	return ret;
}

function setCookie(cname, cvalue) {
	window.localStorage.setItem(cname, cvalue);
}
*/
function s4() {
	return Math.floor((1 + Math.random()) * 0x10000)
		.toString(16)
		.substring(1);
}

function generateGuid() {
	return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
		s4() + '-' + s4() + s4() + s4();
}

function getRandomInt(min, max) { //inc inc
	return Math.floor(Math.random() * (max - min + 1)) + min;
}

// var estimatedMoney = "normal";

function isPMAvailable(C2Callback){
	var isAvailable = "0";
	/*
	if(typeof(navigator.connection) != "undefined"){
		if(navigator.connection.type != "none"){
		//do something
		}
	}
	*/
	if(typeof(navigator.connection) != "undefined"){
		isAvailable = "0";
		if(navigator.connection.type != "none"){
			//do something
			isAvailable = "1";
		}
	}
	if(!TJObj.ready) isAvailable = "0";
	
	if(typeof(C2Callback) == "string" && typeof(c2_callFunction) != 'undefined') c2_callFunction("isPMAvailable", [isAvailable]);
	
	return isAvailable;
}

var TJObj = {ready:false,C2Ready:false,lastRequest:-1,lastBalance:-1,waiting4Balance:false,offersWallWasOpened:true,
			appKey:"", secretKey:"", currencyID:[""],
			timerInterval0:1000, timerInterval1:6000, timerInterval2:12000, timerInterval3:30000, timerInterval4:60000, showCurrencySelector: true,
			EC_UNKNOW:"EC_UNKNOW", EC_NETWORK:"EC_NETWORK", EC_FUNDS:"EC_FUNDS"};
			
function TJSetUIDSuccess(){
	if(typeof(Tapjoy.eventDict) == 'undefined' && typeof(Tapjoy) != 'undefined') Tapjoy.eventDict = {};
	TJObj.ready = true;
	quickGetTapPoints("start");
	// if(lastTJBalance == -1 && C2Ready){
		//autoRefreshTJBalance(false);
	// }
}

function TJConnectFail(){
	// console.log('Unable to connect to TJ, will try again in 20 sec');
	setTimeout(startTJ, 20*1000);
}
function TJSetUIDFail(){
	// console.log('Unable to login to TJ, will try again in 20 sec');
	setTimeout(TJConnectSuccess, 20*1000);
}

function TJConnectSuccess(){
	if(typeof(TJObj.UID) == 'undefined') return false;
	Tapjoy.setUserID(TJObj.UID, TJSetUIDSuccess, TJSetUIDFail);
}
			
function startTJ(){
	if(typeof(Tapjoy) == 'undefined') return;
	// console.log('STARTING TAPJOY');
	if(getLocalStorageItem("TJUID", "") == "") setLocalStorageItem("TJUID", generateGuid());
	TJObj.UID = getLocalStorageItem("TJUID", "");
	if(TJObj.UID != "" && !TJObj.ready){
		if(typeof(window.analytics) != 'undefined')	window.analytics.setUserId(TJObj.UID);
		if(typeof(cr_getC2Runtime().suspend_events) != 'undefined') cr_getC2Runtime().suspend_events.push(onBackToGame);
		Tapjoy.requestTapjoyConnect(TJObj.appKey, TJObj.secretKey, TJConnectSuccess, TJConnectFail);
	}
}
			
eventToFire.registerEvent("c2LayoutChange",
function (args){
	var state = args.state;
	var name = args.name;
	var obj = args.obj;

	setC2Ready();
	switch(name) {
		case "Splash":
		break;
		case "LevelSelect":
		/*
			TJObj.C2Ready = true;
			if(lastTJBalance == -1 && TJObj.eady){
				getTJBalance();
				autoRefreshTJBalance(false);
			}
		*/
		break;
		case "GameMain":
			if(state == "in"){
				userChoosesToReborn = "NA";
			}else if(state == "out"){

			}
		break;
		case "GameOver":
			if(state == "in"){
				if(typeof(window.analytics) != 'undefined')	 window.analytics.trackEvent('user choice','want_to_reborn',userChoosesToReborn);
			}else if(state == "out"){
				
			}
		break;
	}
});

function setC2Ready(){
	if(!TJObj.C2Ready){
		// console.log('C2 is now ready');
		TJObj.C2Ready = true;
		getCurrencyBalance();
	}
}
var onBackToGameFirst=true;
function onBackToGame(loosingFocus){
	if(typeof(loosingFocus) == "boolean"){
		if(loosingFocus)	return;
	}
	if(!TJObj.C2Ready)	return;
	/*
	if(onBackToGameFirst){
		onBackToGameFirst = false;
		return;
	}
	*/
	//setC2Ready();
	if(TJObj.waiting4Balance && !TJObj.offersWallWasOpened) return false;
	if(typeof(Tapjoy) == 'undefined') return false;
	if(typeof(Tapjoy.getTapPoints) == 'undefined') return false;
	if(!TJObj.ready) return false;
	//TJObj.offersWallWasOpened = true;
	TJObj.timer0 = setTimeout(quickGetTapPoints, TJObj.timerInterval0, "try 0");
	TJObj.timer1 = setTimeout(quickGetTapPoints, TJObj.timerInterval1, "try 1");
	TJObj.timer2 = setTimeout(quickGetTapPoints, TJObj.timerInterval2, "try 2");
	TJObj.timer3 = setTimeout(quickGetTapPoints, TJObj.timerInterval3, "try 3");
	TJObj.timer4 = setTimeout(quickGetTapPoints, TJObj.timerInterval4, "try 4");
}

function quickGetTapPoints(reason){
	if(TJObj.waiting4Balance) return false;
	TJObj.waiting4Balance = true;
	// if(typeof(reason) != "undefined") console.log("will query TJ for " + reason);
	Tapjoy.getTapPoints(function(val){
		TJObj.waiting4Balance = false;
		//TJObj.offersWallWasOpened = false;
		setCurrencyBalance(val);
	},function(val){
		TJObj.waiting4Balance = false;
		if(TJObj.lastBalance != -1) setCurrencyBalance(TJObj.lastBalance);
	});
}
var lastPMonCoinsBalanceUpdateRet = false;
var waitingForC2;
function setCurrencyBalance(amount, forceStop){
	if(typeof(forceStop) != "boolean") forceStop = false;
	var dif = parseInt(amount) - TJObj.lastBalance;
	if(dif > 0 && TJObj.lastBalance != -1){
		if(TJObj.offersWallWasOpened){
			if(typeof(window.analytics) != 'undefined') window.analytics.trackEvent('convert','offerwall','success', dif);
		}else{
			if(typeof(window.analytics) != 'undefined') window.analytics.trackEvent('convert','direct play','success', dif);
		}
	}
	if(forceStop || dif != 0 || !TJObj.offersWallWasOpened){
		// console.log("We stop asking TJ");
		if(typeof(TJObj.timer0) != 'undefined') clearTimeout(TJObj.timer0);
		if(typeof(TJObj.timer1) != 'undefined') clearTimeout(TJObj.timer1);
		if(typeof(TJObj.timer2) != 'undefined') clearTimeout(TJObj.timer2);
		if(typeof(TJObj.timer3) != 'undefined') clearTimeout(TJObj.timer3);
		if(typeof(TJObj.timer4) != 'undefined') clearTimeout(TJObj.timer4);
		if(TJObj.offersWallWasOpened && dif != 0) TJObj.offersWallWasOpened = false;
	}
	lastPMonCoinsBalanceUpdateRet = false;
	if(TJObj.lastBalance == -1) dif = 0;
	TJObj.lastBalance = parseInt(amount);
	if(typeof(c2_callFunction) != 'undefined') lastPMonCoinsBalanceUpdateRet = c2_callFunction("PMonCoinsBalanceUpdate", [""+TJObj.lastBalance, ""+dif]);
	if(lastPMonCoinsBalanceUpdateRet != "OK" && TJObj.lastBalance != -1){
		clearInterval(waitingForC2);
		// console.log("Get TJBalance, but C2 do not respond, going to flood");
		waitingForC2 = setInterval(function(){
			// console.log("Flood PMonCoinsBalanceUpdate");
			if(lastPMonCoinsBalanceUpdateRet == "OK"){	clearInterval(waitingForC2);	return;}
			if(typeof(c2_callFunction) != 'undefined')	lastPMonCoinsBalanceUpdateRet = c2_callFunction("PMonCoinsBalanceUpdate", arguments[0]);
			if(lastPMonCoinsBalanceUpdateRet == "OK")	clearInterval(waitingForC2);
		}, 400, [""+TJObj.lastBalance, ""+dif]);
	}
	lastPMonCoinsBalanceUpdateRet = false;
}

function getCurrencyBalance(){
	var dif = 0;
	if(typeof(c2_callFunction) != 'undefined') c2_callFunction("PMonCoinsBalanceUpdate", [""+TJObj.lastBalance, ""+dif]);
}

function getTJBalance(T_ID, C2cbSuccess, C2cbFail, force){
	force = force || "0";
	if(TJObj.waiting4Balance && force != "0") return false;
	if(!TJObj.C2Ready) return false;
	if(typeof(Tapjoy) == 'undefined') return false;
	if(typeof(Tapjoy.getTapPoints) == 'undefined') return false;
	if(!TJObj.ready) return false;
	C2cbSuccess = C2cbSuccess || "";
	C2cbFail = C2cbFail || "";
	var transaction = {transactionId:T_ID, lastBalance:TJObj.lastBalance, C2cbSuccess:C2cbSuccess, C2cbFail:C2cbFail};
	TJObj.waiting4Balance = true;	
	Tapjoy.getTapPoints(	 function(val){
									TJObj.waiting4Balance = false;
									//TJObj.offersWallWasOpened = false;
									var dif = 0;
									if(TJObj.lastBalance != -1) dif = val - TJObj.lastBalance;
									if(typeof(c2_callFunction) != 'undefined') c2_callFunction(this.C2cbSuccess, [""+this.transactionId, "1",""+val, ""+dif]);
									setCurrencyBalance(val);
							}.bind(transaction)
							,function(val){
									TJObj.waiting4Balance = false;
									var erroCode = TJObj.EC_UNKNOW;
									if(val == "Failed to retrieve points from server") erroCode = TJObj.EC_NETWORK;
									if(typeof(c2_callFunction) != 'undefined') c2_callFunction(this.C2cbFail, [""+this.transactionId, "0",erroCode]);
							}.bind(transaction)
						);
}

function spendTJCoins(T_ID, amount, C2cbSuccess, C2cbFail, force){
	force = force || "0";
	if(typeof(amount) != 'number') return false;
	if(amount <= 0) return false;
	amount = parseInt(amount);
	if(!TJObj.C2Ready) return false;
	if(typeof(Tapjoy) == 'undefined') return false;
	if(typeof(Tapjoy.spendTapPoints) == 'undefined') return false;
	if(!TJObj.ready) return false;
	C2cbSuccess = C2cbSuccess || "";
	C2cbFail = C2cbFail || "";
	if(force == "0" && amount > TJObj.lastBalance){
		var erroCode = TJObj.EC_FUNDS;
		if(typeof(c2_callFunction) != 'undefined') c2_callFunction(C2cbFail, [""+this.T_ID, "0",erroCode]);
		return false;
	}	
	// estimatedMoney = "premium";
	var transaction = {transactionId:T_ID, lastBalance:TJObj.lastBalance, dif:-amount, C2cbSuccess:C2cbSuccess, C2cbFail:C2cbFail};
	Tapjoy.spendTapPoints(	amount
							,function(val){
									if(typeof(c2_callFunction) != 'undefined') c2_callFunction(this.C2cbSuccess, [""+this.transactionId, "1",""+val, ""+this.dif]);
									setCurrencyBalance(val);
							}.bind(transaction)
							,function(val){
									var erroCode = TJObj.EC_UNKNOW;
									if(val == "Failed to spend points.") erroCode = TJObj.EC_NETWORK;
									if(val == "Balance too low") erroCode = TJObj.EC_FUNDS;
									if(typeof(c2_callFunction) != 'undefined') c2_callFunction(this.C2cbFail, [""+this.transactionId, "0",erroCode]);
							}.bind(transaction)
						);
	return true;
}

function earnTJCoins(T_ID, amount, C2cbSuccess, C2cbFail){
	if(typeof(amount) != 'number') return false;
	if(amount <= 0) return false;
	amount = parseInt(amount);
	if(!TJObj.C2Ready) return false;
	if(typeof(Tapjoy) == 'undefined') return false;
	if(typeof(Tapjoy.awardTapPoints) == 'undefined') return false;
	if(!TJObj.ready) return false;
	C2cbSuccess = C2cbSuccess || "";
	C2cbFail = C2cbFail || "";
	var transaction = {transactionId:T_ID, lastBalance:TJObj.lastBalance, dif:amount, C2cbSuccess:C2cbSuccess, C2cbFail:C2cbFail};
	Tapjoy.awardTapPoints(	amount
							,function(val){
									if(typeof(c2_callFunction) != 'undefined') c2_callFunction(this.C2cbSuccess, [""+this.transactionId, "1",""+val, ""+this.dif]);
									setCurrencyBalance(val);
							}.bind(transaction)
							,function(val){
									var erroCode = TJObj.EC_UNKNOW;
									if(val == "Failed to award points.") erroCode = TJObj.EC_NETWORK;
									if(typeof(c2_callFunction) != 'undefined') c2_callFunction(this.C2cbFail, [""+this.transactionId, "0",erroCode]);
							}.bind(transaction)
						);
	return true;
}

function showOfferWall(successCallback, failureCallback, moneyID){
	if(typeof(moneyID) == 'undefined') moneyID = 0;
	if(!TJObj.C2Ready 
	|| typeof(Tapjoy.showOffersWithCurrencyID) == 'undefined'
	|| typeof(TJObj.currencyID[moneyID]) == 'undefined'
	|| !TJObj.ready){
		if(typeof(failureCallback) == 'function') failureCallback(TJObj.EC_UNKNOW);
		return false;
	}
	Tapjoy.showOffersWithCurrencyID(TJObj.currencyID[moneyID], TJObj.showCurrencySelector, successCallback, failureCallback);
	return true;
}

function showTJOfferWall(C2successCallback, C2failureCallback, moneyID){
	if(typeof(moneyID) == 'undefined') moneyID = 0;
	if(typeof(Tapjoy.showOffersWithCurrencyID) == 'undefined' || typeof(TJObj.currencyID[moneyID]) == 'undefined' || !TJObj.C2Ready){
		if(typeof(c2_callFunction) != 'undefined' && typeof(C2failureCallback) != 'undefined'){
			if(C2failureCallback != "") c2_callFunction(C2failureCallback, [TJObj.EC_UNKNOW, "0"]);
		}
		return false;
	}
	TJObj.offersWallWasOpened = true;
	var cb = {C2successCallback:C2successCallback, C2failureCallback:C2failureCallback};
	//if(typeof(window.analytics) != 'undefined') window.analytics.trackEvent('offerwall','requests','user action');
	Tapjoy.showOffersWithCurrencyID(TJObj.currencyID[moneyID], TJObj.showCurrencySelector, function(){
		if(typeof(c2_callFunction) != 'undefined' && typeof(this.C2successCallback) != 'undefined'){
			if(this.C2successCallback != "") c2_callFunction(this.C2successCallback, [((typeof(arguments[0]) != 'undefined') ? arguments[0] : ""), "1"]);
		}
		if(typeof(window.analytics) != 'undefined') window.analytics.trackEvent('offerwall','open','success');
	}.bind(cb),  function(){
		if(typeof(c2_callFunction) != 'undefined' && typeof(this.C2failureCallback) != 'undefined'){
			if(this.C2failureCallback != "") c2_callFunction(this.C2failureCallback, [((typeof(arguments[0]) != 'undefined') ? arguments[0] : ""), "0"]);
		}
		if(typeof(window.analytics) != 'undefined') window.analytics.trackEvent('offerwall','open','fail');
	}.bind(cb));
	return true;
}

//---------------------------------------


var TJECB = function(){
	this.eventSuccessFunction				= function(){};
	this.eventFailedFunction				= function(){};
	this.contentDidAppearFunction			= function(){};
	this.contentDidDisappearFunction		= function(){};
	this.didRequestActionFunction			= function(){};
	this.sendEventComplete					= function(){};
	this.sendEventFail						= function(){};
	this.contentWillAppear					= function(){};
	this.contentDidAppear					= function(){};
	this.contentWillDisappear				= function(){};
	this.contentDidDisappear				= function(){};
	this.didRequestAction					= function(){};
	this.contentIsReady						= function(){};
	this.sendEventSucceeded					= function(){};
	this.sendEventFailed					= function(){};
};

var preparedEvents = {};


function prepareTJEvent(eventName, forceParam, C2cbOnReadyStateTrue, C2cbOnReadyStateFalse, repeat, retry){
	// console.log("calling prepareTJEvent");
	if(typeof(repeat) == 'undefined') repeat = true;
	if(typeof(repeat) != 'boolean'){
		if(repeat == "false") repeat = false;
		else repeat = true;
	}
	if(typeof(forceParam) == 'undefined'){
		forceParam = undefined;
	}else if(forceParam == "undefined"){
		forceParam = undefined;
	}
	if(typeof(retry) == 'undefined') retry = 60 * 1000;
	if(typeof(retry) == 'string' && !isNaN(parseInt(retry))) retry = parseInt(retry);
	C2cbOnReadyStateTrue = C2cbOnReadyStateTrue || "";
	C2cbOnReadyStateFalse = C2cbOnReadyStateFalse || "";
	var aTJECB = new TJECB();
	aTJECB.sendEventFailed = function(){
		// console.log('Recieving reply form server for event : ' + this.eventName);
		// console.log(arguments);
		if(arguments[1] != "null"){
			if(this.retry != 0){
				// console.log("will retry in " + this.retry / 1000 + "s");
				setTimeout(prepareTJEvent, this.retry, this.eventName, this.forceParam, this.C2cbOnReadyStateTrue, this.C2cbOnReadyStateFalse, this.repeat, this.retry);
			}
		}else{	//not connected
			//if(this.retry != 0){
				// console.log("no connection will retry in 20s");
				setTimeout(prepareTJEvent, 20 * 1000, this.eventName, this.forceParam, this.C2cbOnReadyStateTrue, this.C2cbOnReadyStateFalse, this.repeat, this.retry);
			//}
		}
		isTJEventReady(this.eventName, this.C2cbOnReadyStateTrue, this.C2cbOnReadyStateFalse);
	}.bind({eventName:eventName, forceParam:forceParam, repeat:repeat, retry:retry, C2cbOnReadyStateTrue:C2cbOnReadyStateTrue, C2cbOnReadyStateFalse:C2cbOnReadyStateFalse});
	aTJECB.contentDidDisappear = function(){};
	aTJECB.sendEventSucceeded = function(event, thereIsInventory){
		// console.log('Recieving reply form server for event : ' + this.eventName);
		// console.log(arguments);
		preparedEvents[this.eventName]['query'] = false;
		if(typeof(thereIsInventory) != 'boolean')	return;
		preparedEvents[this.eventName]['ready'] = thereIsInventory;
		isTJEventReady(this.eventName, this.C2cbOnReadyStateTrue, this.C2cbOnReadyStateFalse);
		// return successCallback(val);
	}.bind({eventName:eventName, forceParam:forceParam, repeat:repeat, retry:retry, C2cbOnReadyStateTrue:C2cbOnReadyStateTrue, C2cbOnReadyStateFalse:C2cbOnReadyStateFalse});
	if(!TJObj.C2Ready /*|| !TJObj.ready*/){
		aTJECB.sendEventFailed();
		return false;
	}else{
		var a = new TJEvent(eventName, forceParam, aTJECB);
		a.eventName = eventName;
		a.enableAutoPresent(false);
		a.send();
		preparedEvents[eventName] = {name:eventName, retry:retry, repeat:repeat, query:true, ready:false, currEvent:a, forceParam:forceParam, aTJECB:aTJECB, C2cbOnReadyStateTrue:C2cbOnReadyStateTrue, C2cbOnReadyStateFalse:C2cbOnReadyStateFalse};
		return true;
	}
}


function isTJEventReady(eventName, cbC2Yes, cbC2No){
	// console.log("calling isTJEventReady");
	cbC2Yes = cbC2Yes || "";
	cbC2No = cbC2No || "";
	var _ret=false;
	if(typeof(preparedEvents[eventName]) == "undefined"){
		_ret = false;
		if(typeof(c2_callFunction) != 'undefined'){
			if(_ret && cbC2Yes !="") c2_callFunction(cbC2Yes, [eventName, "1"]);
			else if(cbC2No !="") c2_callFunction(cbC2No, [eventName, "0"]);
		}
		return ((_ret === true) ? "1": "0");
	}else{
		if(typeof(preparedEvents[eventName]['ready']) == 'undefined'){
			_ret = false;
		}else{
			_ret = preparedEvents[eventName]['ready'];
		}
	}
	//m
	if(!_ret && AppodealAdAvailable){
		_ret = true;
	}
	
	if(typeof(c2_callFunction) != 'undefined'){
		if(_ret && cbC2Yes !="") c2_callFunction(cbC2Yes, [eventName, "1"]);
		else if(cbC2No !="") c2_callFunction(cbC2No, [eventName, "0"]);
	}
	return ((_ret === true) ? "1": "0");
}

function launchTJEvent(eventName, C2cbOnFail, C2cbOnVideoDidAppear, C2cbOnVideoDidDisappear, forceReload, fallBackOnOfferWall){
	if(typeof(preparedEvents[eventName]) == "undefined"){
		if(typeof(C2cbOnFail) != 'undefined' && typeof(c2_callFunction) == 'function'){
			c2_callFunction(C2cbOnFail, [eventName, "0", ((fallBackOnOfferWall === false) ? "0": "1")]);
			if(typeof(window.analytics) != 'undefined' && !fallBackOnOfferWall) window.analytics.trackEvent('direct play', eventName, 'fail-error');
		}
	}
	window.availablesNetworks = [];
	if(AppodealAdAvailable)	availablesNetworks.push("AppoDeal");
	if(typeof(preparedEvents[eventName]['ready']) != 'undefined'){
		if(preparedEvents[eventName]['ready']) availablesNetworks.push("TapJoy");
	}
	if(availablesNetworks.length == 0){
		if(typeof(C2cbOnFail) != 'undefined' && typeof(c2_callFunction) == 'function'){
			c2_callFunction(C2cbOnFail, [eventName, "0", ((fallBackOnOfferWall === false) ? "0": "1")]);
			if(typeof(window.analytics) != 'undefined' && !fallBackOnOfferWall) window.analytics.trackEvent('direct play', eventName, 'fail-error');
		}
	}else{
		var choosenPath = "launch" + availablesNetworks[getRandomInt(0, availablesNetworks.length - 1)] + "Event";
		//
		console.log("Choose ", choosenPath, " from ", availablesNetworks);
		//
		window[choosenPath].apply(this, arguments);
	}
}

function launchAppoDealEvent(eventName, C2cbOnFail, C2cbOnVideoDidAppear, C2cbOnVideoDidDisappear, forceReload, fallBackOnOfferWall){
	if(typeof(preparedEvents[eventName]) == 'undefined'){ 
		console.log("fail",eventName,"fail-error");
		if(typeof(C2cbOnFail) != 'undefined' && typeof(c2_callFunction) == 'function'){
			c2_callFunction(C2cbOnFail, [eventName, "0", ((fallBackOnOfferWall === false) ? "0": "1")]);
			if(typeof(window.analytics) != 'undefined' && !fallBackOnOfferWall) window.analytics.trackEvent('direct play', eventName, 'fail-error');
		}
		return false;
	}
		
	window.AppodealCB = {"eventName" : eventName, "C2cbOnFail" : C2cbOnFail, "C2cbOnVideoDidAppear" : C2cbOnVideoDidAppear, "C2cbOnVideoDidDisappear" : C2cbOnVideoDidDisappear, "forceReload" : forceReload, "fallBackOnOfferWall" : fallBackOnOfferWall};
	
	TJObj.offersWallWasOpened = false;
	//GAME SPECIFIC
	if(eventName == "want_to_reborn"){
		if(userChoosesToReborn == "offerToReborn") userChoosesToReborn = "YES";
		saveAdNb++;
	}
	//END OF GAME SPECIFIC
	Appodeal.show(Appodeal.REWARDED_VIDEO);
	return true;
}

document.addEventListener('onRewardedVideoLoaded', function(){
	console.log("onRewardedVideoLoaded");
});
document.addEventListener('onRewardedVideoFailedToLoad', function(){
	console.log("onRewardedVideoFailedToLoad");
});
/*
document.addEventListener('onRewardedVideoFailedToLoad', function(){
	//
	console.log("onRewardedVideoFailedToLoad");
	if(typeof(window.AppodealCB) == 'undefined') return false;
	if(typeof(window.AppodealCB.eventName) == 'undefined') return false;
	console.log("fail",window.AppodealCB.eventName,"fail-error");
		if(typeof(C2cbOnFail) != 'undefined' && typeof(c2_callFunction) == 'function'){
			c2_callFunction(C2cbOnFail, [eventName, "0", "0"]);
			if(typeof(window.analytics) != 'undefined') window.analytics.trackEvent('direct play', eventName, 'fail-error');
		}
});
*/

document.addEventListener('onRewardedVideoShown', function(){
	//
	console.log("onRewardedVideoShown");
	console.log("appear",window.AppodealCB.eventName);
	if(typeof(window.AppodealCB.C2cbOnVideoDidAppear) != 'undefined' && typeof(c2_callFunction) == 'function') c2_callFunction(window.AppodealCB.C2cbOnVideoDidAppear, [window.AppodealCB.eventName, "1"]);
});
document.addEventListener('onRewardedVideoClosed', function(){
	//
	console.log("onRewardedVideoClosed");
	console.log("didAppear",window.AppodealCB.eventName);
		if(typeof(window.AppodealCB.C2cbOnVideoDidAppear) != 'undefined' && typeof(c2_callFunction) == 'function') c2_callFunction(window.AppodealCB.C2cbOnVideoDidDisappear, [window.AppodealCB.eventName, "1"]);
		if(typeof(window.analytics) != 'undefined') window.analytics.trackEvent('direct play',window.AppodealCB.eventName,'success');
		// console.log("...video ends");
});
	
function launchTapJoyEvent(eventName, C2cbOnFail, C2cbOnVideoDidAppear, C2cbOnVideoDidDisappear, forceReload, fallBackOnOfferWall){
	// console.log("calling launchTJEvent :" + eventName);
	if(typeof(forceReload) == 'undefined') forceReload = false;
	if(typeof(forceReload) == 'string'){
		if(forceReload == "true") forceReload = true;
		else forceReload = false;
	}
	var willBeReloaded = forceReload || false;
	if(typeof(fallBackOnOfferWall) == 'undefined') fallBackOnOfferWall = false;
	if(fallBackOnOfferWall == 'false') fallBackOnOfferWall = false;
	if(typeof(preparedEvents[eventName]) == 'undefined'){ 

		console.log("fail",this.eventName,"fail-error");
		if(typeof(C2cbOnFail) != 'undefined' && typeof(c2_callFunction) == 'function'){
			c2_callFunction(C2cbOnFail, [eventName, "0", ((fallBackOnOfferWall === false) ? "0": "1")]);
			if(typeof(window.analytics) != 'undefined' && !fallBackOnOfferWall) window.analytics.trackEvent('direct play', eventName, 'fail-error');
		}
		if(fallBackOnOfferWall !== false){
			var C2successCallback = "";
			var C2failureCallback = "";
			var moneyID = 0;
			fallBackOnOfferWall = fallBackOnOfferWall.split(";");
			if(typeof(fallBackOnOfferWall[0]) != 'undefined') C2successCallback = fallBackOnOfferWall[0];
			if(typeof(fallBackOnOfferWall[1]) != 'undefined') C2failureCallback = fallBackOnOfferWall[1];
			if(typeof(fallBackOnOfferWall[2]) == 'number') moneyID = parseInt(fallBackOnOfferWall[2]);
			// console.log('Event fail, falling back on offerwall');
			// console.log('showTJOfferWall("' + C2successCallback + '", "'+C2failureCallback+'", '+moneyID+');');
			if(typeof(window.analytics) != 'undefined') window.analytics.trackEvent('direct play', eventName, 'fail-error-fallback');
			showTJOfferWall(C2successCallback, C2failureCallback, moneyID);
		}
		return false;
	}
	willBeReloaded = willBeReloaded || preparedEvents[eventName]['repeat'];
	if(preparedEvents[eventName]['ready'] != true){
		console.log("fail",this.eventName,"not ready");
		if(typeof(C2cbOnFail) != 'undefined' && typeof(c2_callFunction) == 'function'){
			c2_callFunction(C2cbOnFail, [eventName, "0"]);
			if(typeof(window.analytics) != 'undefined' && !fallBackOnOfferWall) window.analytics.trackEvent('direct play', eventName, 'fail-notReady');
		}
		/*
		if(fallBackOnOfferWall !== false){
			if(typeof(window.analytics) != 'undefined') window.analytics.trackEvent('direct play', eventName, 'fallback');
			var C2successCallback = "";
			var C2failureCallback = "";
			if(typeof(fallBackOnOfferWall[0]) != 'undefined') C2successCallback = fallBackOnOfferWall[0];
			if(typeof(fallBackOnOfferWall[1]) != 'undefined') C2failureCallback = fallBackOnOfferWall[1];
			showTJOfferWall(C2successCallback, C2failureCallback);
		}*/
		if(fallBackOnOfferWall !== false){
			var C2successCallback = "";
			var C2failureCallback = "";
			var moneyID = 0;
			fallBackOnOfferWall = fallBackOnOfferWall.split(";");
			if(typeof(fallBackOnOfferWall[0]) != 'undefined') C2successCallback = fallBackOnOfferWall[0];
			if(typeof(fallBackOnOfferWall[1]) != 'undefined') C2failureCallback = fallBackOnOfferWall[1];
			if(typeof(fallBackOnOfferWall[2]) == 'number') moneyID = parseInt(fallBackOnOfferWall[2]);
			// console.log('Event fail, falling back on offerwall');
			// console.log('showTJOfferWall("' + C2successCallback + '", "'+C2failureCallback+'", '+moneyID+');');
			if(typeof(window.analytics) != 'undefined') window.analytics.trackEvent('direct play', eventName, 'fail-notReady-fallback');
			showTJOfferWall(C2successCallback, C2failureCallback, moneyID);
		}
		return false;
	}
	
	preparedEvents[eventName]['currEvent']['eventCallback']['contentDidAppear'] = function(){
		//console.log("appear",this.eventName);
		cr_setSuspended(true);
		if(typeof(this.C2cbOnVideoDidAppear) != 'undefined' && typeof(c2_callFunction) == 'function') c2_callFunction(this.C2cbOnVideoDidAppear, [this.eventName, "1"]);
	}.bind({C2cbOnVideoDidAppear:C2cbOnVideoDidAppear, C2cbOnVideoDidDisappear:C2cbOnVideoDidDisappear, eventName:eventName, willBeReloaded:willBeReloaded, fallBackOnOfferWall:fallBackOnOfferWall});
	preparedEvents[eventName]['currEvent']['eventCallback']['contentDidDisappear'] = function(){
		//console.log("didAppear",this.eventName);
		if(typeof(this.C2cbOnVideoDidAppear) != 'undefined' && typeof(c2_callFunction) == 'function') c2_callFunction(this.C2cbOnVideoDidDisappear, [this.eventName, "1"]);
		if(typeof(window.analytics) != 'undefined') window.analytics.trackEvent('direct play',this.eventName,'success');
		cr_setSuspended(false);
		if(this.willBeReloaded){
			//console.log("next video will be preload for " + this.eventName);
			setTimeout(function(){
				if(typeof(preparedEvents[this.eventName]) != 'undefined'){
					var orgEvent = preparedEvents[this.eventName];
					// console.log("event " + orgEvent.name + " is preloading");
					prepareTJEvent(orgEvent.name, orgEvent.forceParam, orgEvent.C2cbOnReadyStateTrue, orgEvent.C2cbOnReadyStateFalse, orgEvent.repeat, orgEvent.retry);
				}
			}.bind({eventName:this.eventName}),1000);
		}
	}.bind({C2cbOnVideoDidAppear:C2cbOnVideoDidAppear, C2cbOnVideoDidDisappear:C2cbOnVideoDidDisappear, eventName:eventName, willBeReloaded:willBeReloaded, fallBackOnOfferWall:fallBackOnOfferWall});
	
	preparedEvents[eventName]['ready'] = false;
	TJObj.offersWallWasOpened = false;
	//GAME SPECIFIC
	if(eventName == "want_to_reborn"){
		if(userChoosesToReborn == "offerToReborn") userChoosesToReborn = "YES";
		saveAdNb++;
	}
	//END OF GAME SPECIFIC
	preparedEvents[eventName]['currEvent'].show();
	return true;
}
	
function launchTJEventOrOfferWall(successCallback, failureCallback){
	
}

//Game specific
var userChoosesToReborn = "NA";
function want_to_die(){
	if(userChoosesToReborn == "offerToReborn")	userChoosesToReborn = "NO";
}

				//THIS IS READY, JUST BYPASS TAPJOY OBJECT IN ORDER TO TEST IT LOCALY FOR CHARLES


function offerToReborn(success){//	0/1
	//if(userChoosesToReborn != "NA") return;
	if(success == 1) userChoosesToReborn = "offerToReborn";
		else	userChoosesToReborn = "NoVideo";
}


function endless_survivalTime(timeB4Death){
	setTimeout(function(timeB4Death){
		if(typeof(window.analytics) == 'undefined') return;
		var lowerTime = Math.floor(timeB4Death/5)*5;
		var willReturn = lowerTime + " - " + (lowerTime+5);
		window.analytics.trackEvent('endless','survival time', willReturn);
	}, Math.round(1100 + Math.random()*1000), timeB4Death);
}

function buyItem(itemId, moneyId, moneyAmount){
	//console.log(arguments);		estimatedMoney = "premium";
	//moneyAmount wont be used currently
	if(typeof(window.analytics) == 'undefined'){	/* estimatedMoney = "normal";*/	return;	}
	if(typeof(itemId) == 'undefined'){				/* estimatedMoney = "normal";*/	return;	}
	if(typeof(moneyId) == 'undefined'){				/* estimatedMoney = "normal";*/	return;	}
	if(typeof(moneyAmount) == 'undefined') moneyAmount = 0;
	if(isNaN(moneyAmount))	moneyAmount = 0;
	if(moneyAmount < 0)	moneyAmount = Math.abs(moneyAmount);
	//window.analytics.trackEvent('buy',itemId, moneyId);
	//The shop of this game is not normalized so we need to convert data :
	// window.analytics.trackEvent('buy',itemId, ((estimatedMoney == "premium") ? 'diamonds' : 'coins'));
	window.analytics.trackEvent('buy', itemId, ((moneyId == "premium") ? 'diamonds' : 'coins'), moneyAmount);
	// estimatedMoney = "normal";
}